//+------------------------------------------------------------------+
//|                                     Waddah Attar Buy Sell Volume |
//|                               Copyright  2007, ww.metaforex.net |
//| mtf2008fxtsd    ki                Waddah Attar www.metaforex.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, www.metaforex.net"
#property link      "www.metaforex.net"
//----
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color3 Yellow
#property indicator_color4 Aqua
#property indicator_width3 2
#property indicator_width4 2

extern int DataFromTF = 1;
extern string  note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";

//---- buffers
double P1;
double P2;
double Delta;

double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double P4Buffer[];

//----
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);
   SetIndexBuffer(2, P3Buffer);
   SetIndexBuffer(3, P4Buffer);

//----
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_NONE);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexStyle(3, DRAW_HISTOGRAM);


//----
  IndicatorShortName("B/S Vol DataTF M["+DataFromTF+"]");

   IndicatorDigits(0);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   int i,ii;
   static int pii=-1;
   
   for(i = 0; i <iBars(Symbol(),DataFromTF) ; i++)
     {
       ii = iBarShift(Symbol(), Period(), iTime(Symbol(),DataFromTF,i), true);
       //----
       if (pii!=ii)
       {
         P1=0;
         P2=0;

         P1Buffer[ii]=0;
         P2Buffer[ii]=0;
         P3Buffer[ii]=0;
         P4Buffer[ii]=0;

       }
       
       if (ii != -1)
       {
         if (iClose(Symbol(),DataFromTF,i)>iClose(Symbol(),DataFromTF,i+1))
         {
           P1 = P1+(iVolume(Symbol(),DataFromTF,i));
         }
         if (iClose(Symbol(),DataFromTF,i)<iClose(Symbol(),DataFromTF,i+1))
         {
           P2 = P2-(iVolume(Symbol(),DataFromTF,i));
         }
         if (iClose(Symbol(),DataFromTF,i)==iClose(Symbol(),DataFromTF,i+1))
         {
           P1 = P1+(iVolume(Symbol(),DataFromTF,i)/2);
           P2 = P2-(iVolume(Symbol(),DataFromTF,i)/2);
         }
       }
       P1Buffer[ii]=P1;
       P2Buffer[ii]=P2;
       Delta =P1+P2;
      if  ((Delta)>=0) {P4Buffer[ii]=Delta; P3Buffer[ii]=EMPTY_VALUE;}
                  else {P4Buffer[ii]=EMPTY_VALUE; P3Buffer[ii]=Delta;}



       pii=ii;
    }
//----
   return(0);
  }

